-- mainWidget.lua
-- Originally TheOneBagWindow.lua written by Rod, extended by Habna


import "HabnaPlugins.HugeBag.settingsWidget"; -- LUA settings file
import "HabnaPlugins.HugeBag.functionsWidget"; -- LUA functions file
import "HabnaPlugins.HugeBag.optionsWidget"; -- LUA options file
import "HabnaPlugins.HugeBag.moveWidget"; -- LUA MoveWidget file


local resources = {
	  Item = { Background = "HabnaPlugins/HugeBag/Resources/slotBackground.tga" },
	  List = { Background = "HabnaPlugins/HugeBag/Resources/itemListBackground.tga" },
	  HugeBagEmpty = { Image = "HabnaPlugins/HugeBag/Resources/empty.tga" },
	  HugeBagName = { Image = "HabnaPlugins/HugeBag/Resources/label.tga" },
	  HugeBagName_over = { Image = "HabnaPlugins/HugeBag/Resources/label_over.tga" },
	  TopLeftCorner = { Background = "HabnaPlugins/HugeBag/Resources/topLeftCorner.tga" },
	  TopLeftCorner_over = { Background = "HabnaPlugins/HugeBag/Resources/topLeftCorner_over.tga" },
	  TopBar = { Background = "HabnaPlugins/HugeBag/Resources/TopBar.tga" },
	  TopRightCorner = { Background = "HabnaPlugins/HugeBag/Resources/topRightCorner.tga" },
	  TopRightCorner_over = { Background = "HabnaPlugins/HugeBag/Resources/topRightCorner_over.tga" },
	  MidLeftBar = { Background = "HabnaPlugins/HugeBag/Resources/midLeftBar.tga" },
	  MidLeftBar_over = { Background = "HabnaPlugins/HugeBag/Resources/midLeftBar_over.tga" },
	  MidRightBar = { Background = "HabnaPlugins/HugeBag/Resources/midRightBar.tga" },
	  MidRightBar_over = { Background = "HabnaPlugins/HugeBag/Resources/midRightBar_over.tga" },
	  BotLeftCorner = { Background = "HabnaPlugins/HugeBag/Resources/botLeftCorner.tga" },
	  BotLeftCorner_over = { Background = "HabnaPlugins/HugeBag/Resources/botLeftCorner_over.tga" },
	  BotBar = { Background = "HabnaPlugins/HugeBag/Resources/BotBar.tga" }, 
	  BotRightCorner = { Background = "HabnaPlugins/HugeBag/Resources/botRightCorner.tga" },
	  BotRightCorner_over = { Background = "HabnaPlugins/HugeBag/Resources/botRightCorner_over.tga" }
};

frmMain = class( Turbine.UI.Window );
--frmMain = class( Turbine.UI.Lotro.Window );

function frmMain:Constructor()
	Turbine.UI.Window.Constructor( self );
	--Turbine.UI.Lotro.Window.Constructor( self );

	self.cursor = nil;
	
	--**v Get player backpack v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.backpack = Turbine.Gameplay.LocalPlayer.GetInstance():GetBackpack();
	else
		self.backpack = Turbine.Gameplay.LocalPlayer():GetBackpack();
	end
	--**^

	backpackSize = self.backpack:GetSize();

	LoadSettings();
	
	--**v Set some settings of HugeBag window v**
	self:SetWantsKeyEvents( true );
	self:SetVisible( true );

	if ( StartVisible ) then
		windowOpen = true;
		if WidgetLoc == "right" then
			self:SetLeft( screenWidth - WinWidth - 1);
		elseif WidgetLoc == "left" then
			self:SetLeft( 1 );
		end
	else
		windowOpen = false;
		if WidgetLoc == "right" then
			self:SetLeft( screenWidth - 30 );
		elseif WidgetLoc == "left" then
			self:SetLeft( -419 );
		end
	end
	
	self:SetTop( WinLocY );
	--self:SetOpacity( 1 );
	--self:SetAllowDrop( true );
	
	--1 Always on top / 0 Not always on top
	if zOrder then
		self:SetZOrder( 1 );
	else
		self:SetZOrder( 0 );
	end
	--**^

	Turbine.PluginManager.RefreshAvailablePlugins();
	loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();

	HBLBChecker = Turbine.UI.Control();
	HBLBChecker:SetWantsUpdates( true );

	HBLBChecker.Update = function( sender, args )
		for k,v in pairs(loaded_plugins) do
			if v.Name == "HugeBag LootBug" then
				Turbine.PluginManager.UnloadScriptState( 'HugeBagLootBug' );
				if WasOpen then
					windowOpen = true;
					if WidgetLoc == "right" then
						self:SetLeft( screenWidth - WinWidth - 1);
					elseif WidgetLoc == "left" then
						self:SetLeft( 1 );
					end
				else
					windowOpen = false;
					if WidgetLoc == "right" then
						self:SetLeft( screenWidth - 30 );
					elseif WidgetLoc == "left" then
						self:SetLeft( -419 );
					end
				end
				break;
			end
		end
		HBLBChecker:SetWantsUpdates( false );
	end

	--**v Set Top and size of window v** --
	if backpackSize == 45 then
		self:SetSize( WinWidth, WinHeight - 69 );
	else
		self:SetSize( WinWidth, WinHeight );
	end
	--**^

	--**v Slide control v**
	slideCtr = Turbine.UI.Control();

	slideCtr.Update = function( sender, args )
		-- ** Replace if display size has changed
		tscreenWidth, tscreenHeight = Turbine.UI.Display.GetSize();

		if ( tscreenWidth ~= screenWidth ) then
			screenWidth = tscreenWidth;
			if ( windowOpen ) then
				if WidgetLoc == "right" then
					self:SetLeft( screenWidth - WinWidth - 1 );
				elseif WidgetLoc == "left" then
					self:SetLeft( 1 );
				end
			else
				if WidgetLoc == "right" then
					self:SetLeft( screenWidth - 30 );
				elseif WidgetLoc == "left" then
					self:SetLeft( -419 );
				end
			end
		end
		-- **
		
		if WidgetLoc == "right" then
			if ( windowOpen ) then
				if ( self:GetLeft() == ( screenWidth - 30 ) ) then
					slideCtr:SetWantsUpdates( false );
					windowOpen = false;
				else
					self:SetLeft( self:GetLeft() + winRate );
				end
			else
				if ( self:GetLeft() == ( screenWidth - ( winRate * 15 ) ) ) then
					slideCtr:SetWantsUpdates( false );
					windowOpen = true;
				else
					self:SetLeft( self:GetLeft() - winRate );
				end
			end
		elseif WidgetLoc == "left" then
			if ( windowOpen ) then
				if ( self:GetLeft() + self:GetWidth() == 30 ) then
					slideCtr:SetWantsUpdates( false );
					windowOpen = false;
				else
					self:SetLeft( self:GetLeft() - winRate );
				end
			else
				if ( self:GetLeft() + self:GetWidth() == winRate * 15 ) then
					slideCtr:SetWantsUpdates( false );
					windowOpen = true;
				else
					self:SetLeft( self:GetLeft() + winRate );
				end
			end
		end
	end
	--**^
	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( self );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 30, 20 );
	topLeftCorner:SetBackground( resources.TopLeftCorner.Background );

	topLeftCorner.MouseClick = function( sender, args )
		if WidgetLoc == "right" then
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
				menu:ShowMenuAt(self:GetLeft() - 338, self:GetTop());
			end
		end
	end

	topLeftCorner.MouseHover = function( sender, args )
		if WidgetLoc == "right" then
			Loc = "Top";
			MouseHover();
		end
	end

	topLeftCorner.MouseLeave = function ( args )
		if WidgetLoc == "right" then MouseLeave(); end
	end

	topLeftCorner.MouseDown = function( sender, args )
		if WidgetLoc == "right" then MouseDown( sender, args ); end
	end

	topLeftCorner.MouseUp = function( sender, args )
		if WidgetLoc == "right" then MouseUp( sender, args ); end
	end

	topLeftCorner.MouseMove = function( sender, args )
		if WidgetLoc == "right" then MouseMove( sender, args ); end
	end
	--**^
	--**v Middle left bar **
	midLeftBar = Turbine.UI.Control();
	midLeftBar:SetParent( self );
	midLeftBar:SetPosition( 0, 20 );
	midLeftBar:SetSize( 30, self:GetHeight() - 40 );
	midLeftBar:SetBackground( resources.MidLeftBar.Background );

	midLeftBar.MouseEnter = function( sender, args )
		if WidgetLoc == "right" then
			topLeftCorner:SetBackground( resources.TopLeftCorner_over.Background );
			midLeftBar:SetBackground( resources.MidLeftBar_over.Background );
			botLeftCorner:SetBackground( resources.BotLeftCorner_over.Background );
			if not sidebarinfo then llabel:SetBackground( resources.HugeBagName_over.Image ); end
		end
	end
	
	midLeftBar.MouseLeave = function( sender, args )
		if WidgetLoc == "right" then
			topLeftCorner:SetBackground( resources.TopLeftCorner.Background );
			midLeftBar:SetBackground( resources.MidLeftBar.Background );
			botLeftCorner:SetBackground( resources.BotLeftCorner.Background );
			if not sidebarinfo then llabel:SetBackground( resources.HugeBagName.Image ); end
		end
	end

	midLeftBar.MouseClick = function( sender, args )
		if WidgetLoc == "right" then
			if ( args.Button == Turbine.UI.MouseButton.Left ) then
				slideCtr:SetWantsUpdates(true);
				WasOpen = not windowOpen;
				SaveSettings();
			elseif ( args.Button == Turbine.UI.MouseButton.Right ) then
				ReloadHugeBag();
			end
		end
	end
	--**^
	--**v Bottom left corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( self );
	botLeftCorner:SetPosition( 0, self:GetHeight() - 20 );
	botLeftCorner:SetSize( 30, 20 );
	botLeftCorner:SetBackground( resources.BotLeftCorner.Background );

	botLeftCorner.MouseClick = function( sender, args )
		if WidgetLoc == "right" then
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
				itemsmenu:ShowMenuAt(self:GetLeft() - 200, self:GetTop());
			end
		end
	end
	
	botLeftCorner.MouseHover = function( sender, args )
		if WidgetLoc == "right" then
			Loc = "Bot";
			MouseHover();
		end
	end

	botLeftCorner.MouseLeave = function ( args )
		if WidgetLoc == "right" then MouseLeave(); end
	end

	botLeftCorner.MouseDown = function( sender, args )
		if WidgetLoc == "right" then MouseDown( sender, args ); end
	end

	botLeftCorner.MouseUp = function( sender, args )
		if WidgetLoc == "right" then MouseUp( sender, args ); end
	end

	botLeftCorner.MouseMove = function( sender, args )
		if WidgetLoc == "right" then MouseMove( sender, args ); end
	end
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( self );
	topRightCorner:SetPosition( self:GetWidth() - 30, 0 );
	topRightCorner:SetSize( 30, 20 );
	topRightCorner:SetBackground( resources.TopRightCorner.Background );

	topRightCorner.MouseClick = function( sender, args )
		if WidgetLoc == "left" then
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
				menu:ShowMenuAt(self:GetLeft() + self:GetWidth() + 5, self:GetTop());
			end
		end
	end

	topRightCorner.MouseHover = function( sender, args )
		if WidgetLoc == "left" then
			Loc = "Top";
			MouseHover();
		end
	end

	topRightCorner.MouseLeave = function ( args )
		if WidgetLoc == "left" then	MouseLeave(); end
	end

	topRightCorner.MouseDown = function( sender, args )
		if WidgetLoc == "left" then	MouseDown( sender, args ); end
	end

	topRightCorner.MouseUp = function( sender, args )
		if WidgetLoc == "left" then	MouseUp( sender, args ); end
	end

	topRightCorner.MouseMove = function( sender, args )
		if WidgetLoc == "left" then	MouseMove( sender, args ); end
	end
	--**^
	--**v Middle right bar v**
	midRightBar = Turbine.UI.Control();
	midRightBar:SetParent( self );
	midRightBar:SetPosition( self:GetWidth() - 30, 20 );
	midRightBar:SetSize( 30, self:GetHeight() - 40 );
	midRightBar:SetBackground( resources.MidRightBar.Background );

	midRightBar.MouseEnter = function( sender, args )
		if WidgetLoc == "left" then
			topRightCorner:SetBackground( resources.TopRightCorner_over.Background );
			midRightBar:SetBackground( resources.MidRightBar_over.Background );
			botRightCorner:SetBackground( resources.BotRightCorner_over.Background );
			if not sidebarinfo then rlabel:SetBackground( resources.HugeBagName_over.Image ); end
		end
	end

	midRightBar.MouseLeave = function( sender, args )
		if WidgetLoc == "left" then
			topRightCorner:SetBackground( resources.TopRightCorner.Background );
			midRightBar:SetBackground( resources.MidRightBar.Background );
			botRightCorner:SetBackground( resources.BotRightCorner.Background );
			if not sidebarinfo then rlabel:SetBackground( resources.HugeBagName.Image ); end
		end
	end

	midRightBar.MouseClick = function( sender, args )
		if WidgetLoc == "left" then
			if ( args.Button == Turbine.UI.MouseButton.Left ) then
				slideCtr:SetWantsUpdates(true);
				WasOpen = not windowOpen;
				SaveSettings();
			elseif ( args.Button == Turbine.UI.MouseButton.Right ) then
				ReloadHugeBag();
			end
		end
	end
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( self );
	botRightCorner:SetPosition( self:GetWidth() - 30, self:GetHeight() - 20 );
	botRightCorner:SetSize( 30, 20 );
	botRightCorner:SetBackground( resources.BotRightCorner.Background );

	botRightCorner.MouseClick = function( sender, args )
		if WidgetLoc == "left" then
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
				itemsmenu:ShowMenuAt(self:GetLeft() + self:GetWidth() + 5, self:GetTop());
			end
		end
	end

	botRightCorner.MouseHover = function( sender, args )
		if WidgetLoc == "left" then
			Loc = "Bot";
			MouseHover();
		end
	end

	botRightCorner.MouseLeave = function ( args )
		if WidgetLoc == "left" then	MouseLeave(); end
	end

	botRightCorner.MouseDown = function( sender, args )
		if WidgetLoc == "left" then	MouseDown( sender, args ); end
	end

	botRightCorner.MouseUp = function( sender, args )
		if WidgetLoc == "left" then	MouseUp( sender, args ); end
	end

	botRightCorner.MouseMove = function( sender, args )
		if WidgetLoc == "left" then	MouseMove( sender, args ); end
	end
	--**^
	--**v Top bar v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( self );
	TopBar:SetPosition( 30, 0 );
	TopBar:SetSize( self:GetWidth() - 60, 30 );
	TopBar:SetBackground( resources.TopBar.Background );
	--**^
	--**v Bottom bar V**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( self );
	BotBar:SetPosition( 30, self:GetHeight() - 30);
	BotBar:SetSize( self:GetWidth() - 60, 30 );
	BotBar:SetBackground( resources.BotBar.Background );
	-- **^
	--**v Label on left bar v**
	llabel = Turbine.UI.Label();
	llabel:SetParent( midLeftBar );
	llabel:SetPosition( 6, ( midRightBar:GetHeight() / 2 ) - 75 );
	llabel:SetSize( 19, 150 );
	llabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	llabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro19 );
	llabel:SetForeColor( rustedgold );
	llabel:SetOutlineColor( black );
	llabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	llabel:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	llabel:SetMouseVisible( false );
	--**^
	--**v Label on right bar v**
	rlabel = Turbine.UI.Label();
	rlabel:SetParent( midRightBar );
	rlabel:SetPosition( 6, ( midLeftBar:GetHeight() / 2 ) - 75 );
	rlabel:SetSize( 19, 150 );
	rlabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	rlabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro19 );
	rlabel:SetForeColor( rustedgold );
	rlabel:SetOutlineColor( black );
	rlabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	rlabel:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	rlabel:SetMouseVisible( false );
	--**^
	--**v Sort button on bottom bar v**
	SortButton = Turbine.UI.Button();
	SortButton:SetParent( BotBar );
	SortButton:SetPosition( SortLeft, 8 );
	SortButton:SetSize( 45, 12 );
	SortButton:SetOutlineColor( black );
	SortButton:SetForeColor( grey );
	SortButton:SetFontStyle( Turbine.UI.FontStyle.Outline );
	SortButton:SetText( "Sort" );

	SortButton.MouseClick = function(sender, args)
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			Sort();
		else
			FromButton = "Sort";
			if ( SortButton:GetLeft() == MidPos ) then buttonmenu:ShowMenu(); else Mix(); end
		end
	end

	SortButton.MouseHover = function(sender, args)
		SortButton:SetForeColor( green );
	end

	SortButton.MouseLeave = function(sender, args)
		SortButton:SetForeColor( grey );
	end
	--**^
	--**v Search button on bottom bar v**
	SearchButton = Turbine.UI.Button();
	SearchButton:SetParent( BotBar );
	SearchButton:SetPosition( SearchLeft, 8 );
	SearchButton:SetSize( 45, 12 );
	SearchButton:SetOutlineColor( black );
	SearchButton:SetForeColor( grey );
	SearchButton:SetFontStyle( Turbine.UI.FontStyle.Outline );
	SearchButton:SetText( "Search" );

	SearchButton.MouseClick = function(sender, args)
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			SortButton:SetVisible( false );
			SearchButton:SetVisible( false );
			MergeButton:SetVisible( false );
			SearchInput:SetVisible( not SearchInput:IsVisible() );
			ResetAllCheck(); --Reset all itemsmenu check
			SearchInput:Focus();
		else
			FromButton = "Search";
			if ( SearchButton:GetLeft() == MidPos ) then buttonmenu:ShowMenu(); end
		end
	end

	SearchButton.MouseHover = function(sender, args)
		SearchButton:SetForeColor( green );
	end

	SearchButton.MouseLeave = function(sender, args)
		SearchButton:SetForeColor( grey );
	end
	--**^
	--**v Merge button on bottom bar v**
	MergeButton = Turbine.UI.Button();
	MergeButton:SetParent( BotBar );
	MergeButton:SetPosition( MergeLeft, 8 );
	MergeButton:SetSize( 45, 12 );
	MergeButton:SetOutlineColor( black );
	MergeButton:SetForeColor( grey );
	MergeButton:SetFontStyle( Turbine.UI.FontStyle.Outline );
	MergeButton:SetText( "Merge" );

	MergeButton.MouseClick = function(sender, args)
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			Merge();
		else
			FromButton = "Merge";
			if ( MergeButton:GetLeft() == MidPos ) then buttonmenu:ShowMenu(); end
		end
	end

	MergeButton.MouseHover = function(sender, args)
		MergeButton:SetForeColor( green );
	end

	MergeButton.MouseLeave = function(sender, args)
		MergeButton:SetForeColor( grey );
	end
	--**^
	--**v Text box on bottom bar v**
	SearchInput = Turbine.UI.Lotro.TextBox();
	SearchInput:SetParent( BotBar );
	SearchInput:SetPosition( SortLeft, 4 );
	SearchInput:SetSize( 160, 20 );
	SearchInput:SetMultiline( false );
	SearchInput:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );
	SearchInput.Text = "";
	SearchInput:SetText( SearchInput.Text );
	SearchInput:SetVisible( false );

	SearchInput.FocusGained = function()
		SearchInput:SetWantsUpdates( true );
	end
	
	SearchInput.FocusLost = function()
		SearchInput:SetWantsUpdates( false );
		SearchInput:SetText( "" );
		SearchInput:SetVisible( false );
		if ShowButton then
			SortButton:SetVisible( true );
			SearchButton:SetVisible( true );
			MergeButton:SetVisible( true );
		end
		Search();
		AllVisible = true;
	end
	
	SearchInput.Update = function()
		Search();
	end
	--**^
	--**v Slots informations on top bar v**
	lblTitle = Turbine.UI.Label();
	lblTitle:SetParent( self );
	lblTitle:SetSize( self:GetWidth() - 60, 30 );
	lblTitle:SetPosition( 30, 2 );
	lblTitle:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblTitle:SetFont( Turbine.UI.Lotro.Font.TrajanPro19 );
	lblTitle:SetForeColor( rustedgold );
	lblTitle:SetOutlineColor( black );
	lblTitle:SetFontStyle( Turbine.UI.FontStyle.Outline );
	lblTitle:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	--**^
	--**v Set some settings of the itemlistbox v**
	self.itemListBox = Turbine.UI.ListBox();
	self.itemListBox:SetParent( self );
	self.itemListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.itemListBox:SetPosition( InitXPos, InitYPos );
	self.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	self.itemListBox:SetMaxItemsPerLine( 11 );
	--self.itemListBox:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	self.itemListBox:SetAllowDrop( true );

	self.itemListBox.DragDrop = function( sender, args )
		--write("drag/drop");
		local shortcut = args.DragDropInfo:GetShortcut();
		local destinationItemControl = self.itemListBox:GetItemAt( args.X, args.Y );
		
		if ( destinationItemControl ~= nil ) then -- ** if nil, then it's out of range, so don't do anything **
			local destinationIndex = self.itemListBox:IndexOfItem( destinationItemControl );
			self.backpack:PerformShortcutDrop(shortcut, destinationIndex, Turbine.UI.Control.IsShiftKeyDown() );
		end
	end
	-- **^

	if backpackSize == 45 then
		self.itemListBox:SetSize( 389, 180 ); -- to show 45 slots
	else
		self.itemListBox:SetSize( 389, 249 ); -- to show 75 slots
	end
	--**^
	--**v Backpack v**
	self:SetBackPack(); --> ** Set the backpack **

	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			if ( HideWEsc ) then
				if ( windowOpen ) then
					slideCtr:SetWantsUpdates(true);
					WasOpen = not windowOpen;
					SaveSettings();
				end
			else
				self:SetVisible( true ); -- **v DO NOT Hide HugeBag if ESC key is press v**
			end
		end
		
		if ( args.Action == 268435635 ) then -- **v Hide HugeBag if F12 key is press v**
			self:SetVisible( F12Press );
			F12Press = not F12Press;
		end
		
		-- **v Show HugeBag if any key bound is press v**
		if ( args.Action == Turbine.UI.Lotro.Action.ToggleBags or
		     args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag4 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag5 )
		then
			if not F12Press then -- **v show HugeBag only if F12 key was not press v**
				slideCtr:SetWantsUpdates(true);
				WasOpen = not windowOpen;
				SaveSettings();
			end
		end
	end

	self.backpack.ItemAdded = function( sender, args )
		--write("item added to index " .. args.Index);
		bAdd = true;
		AddTime = Turbine.Engine.GetGameTime();
		--write("bAdd: " .. tostring(bAdd) .. " bMov: " .. tostring(bMov));
		self.items[args.Index]:SetItem( self.backpack:GetItem( args.Index ) );
		freeslots = freeslots - 1;
		self:PrintTitle();
	end
	
	self.backpack.ItemRemoved = function( sender, args )
		--write("item removed from index " .. args.Index);
		--write("bAdd: " .. tostring(bAdd) .. " bMov: " .. tostring(bMov));
		if bAdd and not bMov then
			RemTime = Turbine.Engine.GetGameTime();
			elapsed = RemTime - AddTime;
			--write("elapsed: " .. tostring(elapsed));
			if elapsed == 0 then bGo = true; end
		end
		self.items[args.Index]:SetItem( nil );
		bAdd, bMov = false, false;

		freeslots = freeslots + 1;
		self:PrintTitle();

		if bGo then ReloadHugeBag(); end
	end
	
	self.backpack.ItemMoved = function( sender, args )
		--write("item moved from index " .. args.OldIndex .. " to " .. args.NewIndex);
		bMov = true;
		self.items[args.OldIndex]:SetItem( self.backpack:GetItem( args.OldIndex ) );
		self.items[args.NewIndex]:SetItem( self.backpack:GetItem( args.NewIndex ) );
	end
end

--**v Set the backpack v**
function frmMain:SetBackPack()
	self.items = nil;
	itemsCtl = nil;
	itemsLbl = nil;
	self.itemListBox:ClearItems();
	freeslots = 0;
	
	self.items = {};
	itemsCtl = {};
	itemsLbl = {};
	
	for i = 1, backpackSize do
		-- Item background
		itemsCtl[i] = Turbine.UI.Control();
		itemsCtl[i]:SetSize( 35, 35 );
		itemsCtl[i]:SetBackground( resources.Item.Background );
		itemsCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Slot num in background
		itemsLbl[i] = Turbine.UI.Label();
		itemsLbl[i]:SetParent( itemsCtl[i] );
		itemsLbl[i]:SetSize( 15, 15 );
		itemsLbl[i]:SetPosition( 10, 10 );
		itemsLbl[i]:SetText( i );
		itemsLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		itemsLbl[i]:SetForeColor( verylightgrey );
		itemsLbl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Item
		self.items[i] = Turbine.UI.Lotro.ItemControl( self.backpack:GetItem( i ) );
		self.items[i]:SetParent( itemsCtl[i] );

		if ( self.backpack:GetItem( i ) == nil ) then freeslots = freeslots + 1; end

		self.itemListBox:AddItem( itemsCtl[i] );
	end
	
	frmMain:PrintTitle()
end
--**^
--**v Print the title with the free slots and the max v**
function frmMain:PrintTitle()
	local usedslots = backpackSize - freeslots;

	--top bar
	if topbarinfo == "title" then
		lblTitle:SetText( "HugeBag" );
	elseif topbarinfo == "info" then
		lblTitle:SetText( "HugeBag  --  " .. "Free: " .. freeslots .. "  Used: " .. usedslots .. "  Max: " .. backpackSize );
	elseif topbarinfo == "nil" then
		lblTitle:SetText( "" );
	end

	--side bar
	if WidgetLoc == "right" then
		if sidebarinfo == "info" then
			llabel:SetBackground( resources.HugeBagEmpty.Image );
			if freeslots <= 9 then
				llabel:SetText( "F " .. freeslots .. " \nU " )
			else
				llabel:SetText( "F " .. freeslots .. "\nU " );
			end
			if usedslots <= 9 then
				llabel:SetText( llabel:GetText() .. usedslots .. " \nM " .. backpackSize );
			else
				llabel:SetText( llabel:GetText() .. usedslots .. "\nM " .. backpackSize );
			end
			rlabel:SetText("");
		elseif sidebarinfo == "image" then
			llabel:SetText("");
			rlabel:SetText("");
			llabel:SetBackground( resources.HugeBagName.Image );
			rlabel:SetBackground( resources.HugeBagEmpty.Image );
		elseif sidebarinfo == "nil" then
			llabel:SetBackground( resources.HugeBagEmpty.Image );
			llabel:SetText("");
		end
	else
		if sidebarinfo == "info" then
			rlabel:SetBackground( resources.HugeBagEmpty.Image );
			if freeslots <= 9 then
				rlabel:SetText( "F " .. freeslots .. " \nU" );
			else
				rlabel:SetText( "F " .. freeslots .. "\nU" );
			end
			if usedslots <= 9 then
				rlabel:SetText( rlabel:GetText() .. usedslots .. " \nM" .. backpackSize );
			else
				rlabel:SetText( rlabel:GetText() .. usedslots .. "\nM" .. backpackSize );
			end
			llabel:SetText("");
		elseif sidebarinfo == "image" then
			rlabel:SetText("");
			llabel:SetText("");
			llabel:SetBackground( resources.HugeBagEmpty.Image );
			rlabel:SetBackground( resources.HugeBagName.Image );
		elseif sidebarinfo == "nil" then
			rlabel:SetBackground( resources.HugeBagEmpty.Image );
			rlabel:SetText("");
		end
	end

	--bottom bar
	
end
--**^