-- settings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	InitXPos, InitYPos = 17,33; --> ** Initial X & Y position of the first Item in the HugeBag **
	edgePadding = 15; --> ** HugeBag initial edgePadding value **
	LockLabel = self; --> ** Label that prevents from moving the window cause it's located at top
	ClicX, ClicY = 0, 0; --> To know the x,y coord when mouse button was clic

	--settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWindowSettings" );

	if settings == nil then
		--WinLocX = Turbine.UI.Display.GetWidth() - edgePadding - WinWidth;
		--WinLocY = Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55;
		--SaveSettings();
		settings = {};
	end

	if settings.Size == nil then
		settings.Size = {};
		settings.Size.W = tostring(460);
		settings.Size.H = tostring(300);
	else
		if settings.Size.W == nil then
			settings.Size.W = tostring(460);
		else
			if type(settings.Size.W) ~= "string" then settings.Size.W = tostring(settings.Size.W); end
		end
		if settings.Size.H == nil then
			settings.Size.H = tostring(300);
		else
			if type(settings.Size.H) ~= "string" then settings.Size.H = tostring(settings.Size.H); end
		end
	end

	WinWidth = tonumber(settings.Size.W);
	WinHeight = tonumber(settings.Size.H);

	if settings.Location == nil then
		settings.Location = {};
		settings.Location.X = tostring(screenWidth - edgePadding - WinWidth);
		settings.Location.Y = tostring(screenHeight - edgePadding - WinHeight - 55);
	else
		if settings.Location.X == nil then
			settings.Location.X = tostring(Turbine.UI.Display.GetWidth() - edgePadding - WinWidth);
		else
			if type(settings.Location.X) ~= "string" then settings.Location.X = tostring(settings.Location.X); end
		end
		if settings.Location.Y == nil then
			settings.Location.Y = tostring(Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55);
		else
			if type(settings.Location.Y) ~= "string" then settings.Location.Y = tostring(settings.Location.Y); end
		end
	end

	WinLocX = tonumber(settings.Location.X);
	WinLocY = tonumber(settings.Location.Y);

	-- Need to go out of bound when no skin on HugeBag
	-- **v Replace HugeBag if out of the screen on load v**
	--if ( WinLocX + WinWidth ) > screenWidth then WinLocX = screenWidth - WinWidth end
	--if ( WinLocY + WinHeight ) > screenHeight then WinLocY = screenHeight - WinHeight end
	-- **^

	if settings.BackColor == nil then
		settings.BackColor = {};
		settings.BackColor.A = tostring(1);
		settings.BackColor.R = tostring(0);
		settings.BackColor.G = tostring(0);
		settings.BackColor.B = tostring(0);
	else
		if settings.BackColor.A == nil then
			settings.BackColor.A = tostring(1);
		else
			if type(settings.BackColor.A) ~= "string" then settings.BackColor.A = tostring(settings.BackColor.A); end
		end
		if settings.BackColor.R == nil then
			settings.BackColor.R = tostring(0);
		else
			if type(settings.BackColor.R) ~= "string" then settings.BackColor.R = tostring(settings.BackColor.R); end
		end
		if settings.BackColor.G == nil then
			settings.BackColor.G = tostring(0);
		else
			if type(settings.BackColor.G) ~= "string" then settings.BackColor.G = tostring(settings.BackColor.G); end
		end
		if settings.BackColor.B == nil then
			settings.BackColor.B = tostring(0);
		else
			if type(settings.BackColor.B) ~= "string" then settings.BackColor.B = tostring(settings.BackColor.B); end
		end
	end

	bcAlpha = tonumber(settings.BackColor.A);
	bcRed = tonumber(settings.BackColor.R);
	bcGreen = tonumber(settings.BackColor.G);
	bcBlue = tonumber(settings.BackColor.B);

	if settings.Options == nil then
		settings.Options = {};
		settings.Options.StartVisible = false;
		settings.Options.ShowSlotsInfo = true;
		settings.Options.HideWEsc = true;
		settings.Options.LockPosition = false;
		settings.Options.LockSize = false;
		settings.Options.ShowSkin = true;
		settings.Options.ShowTitle = true;
		settings.Options.AlwaysOnTop = true;
	else
		if settings.Options.StartVisible == nil then
			settings.Options.StartVisible = false;
		end
		if settings.Options.ShowSlotsInfo == nil then
			settings.Options.ShowSlotsInfo = true;
		end
		if settings.Options.HideWEsc == nil then
			settings.Options.HideWEsc = true;
		end
		if settings.Options.LockPosition == nil then
			settings.Options.LockPosition = false;
		end
		if settings.Options.LockSize == nil then
			settings.Options.LockSize = false;
		end
		if settings.Options.ShowSkin == nil then
			settings.Options.ShowSkin = true;
		end
		if settings.Options.ShowTitle == nil then
			settings.Options.ShowTitle = true;
		end
		if settings.Options.AlwaysOnTop == nil then
			settings.Options.AlwaysOnTop = true;
		end
	end

	StartVisible = settings.Options.StartVisible;
	ShowSlotsInfo = settings.Options.ShowSlotsInfo;
	HideWEsc = settings.Options.HideWEsc;
	LockPosition = settings.Options.LockPosition;
	LockSize = settings.Options.LockSize;
	ShowSkin = settings.Options.ShowSkin;
	ShowTitle = settings.Options.ShowTitle;
	zOrder = settings.Options.AlwaysOnTop;
	
	if settings.ButtonPos == nil then
		settings.ButtonPos = {};
		settings.ButtonPos.ShowButton = true;
		settings.ButtonPos.AtTop = false;
		settings.ButtonPos.AtLeft = true;
		settings.ButtonPos.MidPos = tostring(85);
		settings.ButtonPos.Sort = tostring(35);
		settings.ButtonPos.Search = tostring(85);
		settings.ButtonPos.Merge = tostring(135);
	else
		if settings.ButtonPos.ShowButton == nil then
			settings.ButtonPos.ShowButton = true;
		end
		if settings.ButtonPos.AtTop == nil then
			settings.ButtonPos.AtTop = false;
		end
		if settings.ButtonPos.AtLeft == nil then
			settings.ButtonPos.AtLeft = true;
		end
		if settings.ButtonPos.MidPos == nil then
			settings.ButtonPos.MidPos = tostring(85);
		else
			if type(settings.ButtonPos.MidPos) ~= "string" then settings.ButtonPos.MidPos = tostring(settings.ButtonPos.MidPos); end
		end
		if settings.ButtonPos.Sort == nil then
			settings.ButtonPos.Sort = tostring(35);
		else
			if type(settings.ButtonPos.Sort) ~= "string" then settings.ButtonPos.Sort = tostring(settings.ButtonPos.Sort); end
		end
		if settings.ButtonPos.Search == nil then
			settings.ButtonPos.Search = tostring(85);
		else
			if type(settings.ButtonPos.Search) ~= "string" then settings.ButtonPos.Search = tostring(settings.ButtonPos.Search); end
		end
		if settings.ButtonPos.Merge == nil then
			settings.ButtonPos.Merge = tostring(135);
		else
			if type(settings.ButtonPos.Merge) ~= "string" then settings.ButtonPos.Merge = tostring(settings.ButtonPos.Merge); end
		end
	end

	ShowButton = settings.ButtonPos.ShowButton;
	ButtonAtTop = settings.ButtonPos.AtTop;
	ButtonAtLeft = settings.ButtonPos.AtLeft;
	MidPos = tonumber(settings.ButtonPos.MidPos);
	SortLeft = tonumber(settings.ButtonPos.Sort);
	SearchLeft = tonumber(settings.ButtonPos.Search);
	MergeLeft = tonumber(settings.ButtonPos.Merge);
	LeftPos = MidPos - 50;
	RightPos = MidPos + 50;

	if settings.Items == nil then
		settings.Items = {};
		settings.Items.HorizontalOrientation = true;
		settings.Items.ReverseFill = false;
	else
		if settings.Items.HorizontalOrientation == nil then
			settings.Items.HorizontalOrientation = true;
		end
		if settings.Items.ReverseFill == nil then
			settings.Items.ReverseFill = false;
		end
		
	end
	
	HorizontalOrientation = settings.Items.HorizontalOrientation;
	ReverseFill = settings.Items.ReverseFill;

	if settings.Version == nil then	settings.Version = Version; end

	if settings.WasVisible == nil then settings.WasVisible = false; end

	WasVisible = settings.WasVisible;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettings", settings );
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.WasVisible = WasVisible;

	settings.Location = {};
	settings.Location.X = tostring(WinLocX);
	settings.Location.Y = tostring(WinLocY);

	settings.Size = {};
	settings.Size.W = tostring(WinWidth);
	settings.Size.H = tostring(WinHeight);

	settings.Options = {};
	settings.Options.StartVisible = StartVisible;
	settings.Options.ShowSlotsInfo = ShowSlotsInfo;
	settings.Options.HideWEsc = HideWEsc;
	settings.Options.LockPosition = LockPosition;
	settings.Options.LockSize = LockSize;
	settings.Options.ShowSkin = ShowSkin;
	settings.Options.ShowTitle = ShowTitle;
	settings.Options.AlwaysOnTop = zOrder;

	settings.BackColor = {};
	settings.BackColor.A = tostring(bcAlpha);
	settings.BackColor.R = tostring(bcRed);
	settings.BackColor.G = tostring(bcGreen);
	settings.BackColor.B = tostring(bcBlue);

	settings.ButtonPos = {};
	settings.ButtonPos.ShowButton = ShowButton;
	settings.ButtonPos.AtTop = ButtonAtTop;
	settings.ButtonPos.AtLeft = ButtonAtLeft;
	settings.ButtonPos.MidPos = tostring(MidPos);
	settings.ButtonPos.Sort = tostring(SortLeft);
	settings.ButtonPos.Search = tostring(SearchLeft);
	settings.ButtonPos.Merge = tostring(MergeLeft);

	settings.Items = {};
	settings.Items.HorizontalOrientation = HorizontalOrientation;
	settings.Items.ReverseFill = ReverseFill;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettings", settings );

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset Location and Size Settings v**
function ResetLSSettings()
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition();
	frmMain:SetVisible( true );
	if not ButtonAtLeft then
		if ( self:GetWidth() >= 218 ) then
			ButtonsLeft();
			ButtonsRight();
		end
	end
	frmMain:PerformLayout();
	frmMain:PrintTitle();
	SaveSettings();
	Turbine.Shell.WriteLine( "HugeBag: My location and size was set back to default" );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	StartVisible = true;
	HBWasVisible = true;
	ShowSlotsInfo = true;
	HideWEsc = true;
	LockPosition = true;
	LockHugeBagPosition();
	LockSize = true;
	LockHugeBagSize();
	Widget = Widget;
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	bcAlpha, bcRed, bcGreen, bcBlue = 1, 0, 0, 0;
	frmMain.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	frmMain:SetVisible( true );
	ShowSkin = false;
	ToggleSkin();
	ShowTitle = false;
	ToggleTitle();
	ShowButton = false;
	ToggleButton();
	ButtonAtTop = false;
	ButtonAtLeft = true;
	ButtonsPos = "left";
	LeftPos, MidPos, RightPos = 35, 85, 135;
	TopPos = frmMain:GetHeight() - 13;
	SortLeft, SearchLeft, MergeLeft = LeftPos, MidPos, RightPos;
	HorizontalOrientation = true;
	--ReverseFill = false;
	zOrder = true;
	frmMain:PerformLayout();
	frmMain:PrintTitle();
	SaveSettings();
	Turbine.Shell.WriteLine( "HugeBag: All my settings was set back to default" );
end
-- **^